/*
 * gc global variable provides access to GUI Composer infrastructure components and project information.
 * For more information, please see the Working with Javascript guide in the online help.
 */
var gc = gc || {};
gc.services = gc.services || {};

/* 
 * To see the console logs logged by this file, in the console view, enter the following:
 * gc.console.setCookie("pamb.js", <value>) 
 * Where value: 0 = remove the cookie, 1 = only errors, 2 = errors and warnings, 3 = errors,warnings,info, 4 = errors,warnings,info,logs, 5=debug+all others
 * For more help on how to work with gc.console, please see the help text that is sent to the
 * console when the app starts.
 */
//if (!gc.designer) { gc.console.setCookie("pamb.js", 5); }         // NOTE: Changing to setLevel() in GC3


// Auto detect serial COM port??
gc.autoDetectPortIdentity = function(port, helperAPI) {
    if (port.productId !== "00AC")
        return; // return undefined for unknown port for identification.

   return "INA237_238EVM";  //TODO: Check if this is the value we want to return
};


/*
 *  Boilerplate code for creating computed data bindings
 */
document.addEventListener('gc-databind-ready', function() {
    
});


/*
 *  Boilerplate code for creating custom actions
 */
document.addEventListener('gc-nav-ready', function() {
    
    // TODO: Add Save data to file button

});


/*
 *  Boilerplate code for working with components in the application gist
 */
/*
const LIBUSB_TRANSFER_TYPE_CONTROL = 0;
const LIBUSB_TRANSFER_TYPE_ISOCHRONOUS = 1;
const LIBUSB_TRANSFER_TYPE_BULK = 2;
const LIBUSB_TRANSFER_TYPE_INTERRUPT = 3;
const LIBUSB_ISO_SYNC_TYPE_NONE = 0;
const LIBUSB_ISO_SYNC_TYPE_ASYNC = 1;
const LIBUSB_ISO_SYNC_TYPE_ADAPTIVE = 2;
const LIBUSB_ISO_SYNC_TYPE_SYNC = 3;
const LIBUSB_ISO_USAGE_TYPE_DATA = 0;
const LIBUSB_ISO_USAGE_TYPE_FEEDBACK = 1;
const LIBUSB_ISO_USAGE_TYPE_IMPLICIT = 2;

const LIBUSB_CLASS_PER_INTERFACE = 0;
const LIBUSB_CLASS_AUDIO = 1;
const LIBUSB_CLASS_COMM = 2;
const LIBUSB_CLASS_HID = 3;
const LIBUSB_CLASS_PTP = 6;
const LIBUSB_CLASS_PRINTER = 7;
const LIBUSB_CLASS_MASS_STORAGE = 8;
const LIBUSB_CLASS_HUB = 9;
const LIBUSB_CLASS_DATA = 10; // CDC Data
const LIBUSB_CLASS_SMART_CARD = 11;
const LIBUSB_CLASS_CONTENT_SECURITY = 13;
const LIBUSB_CLASS_VIDEO = 14;
const LIBUSB_CLASS_PERSONAL_HEALTHCARE = 15;
const LIBUSB_CLASS_AUDIOVIDEO = 16;
const LIBUSB_CLASS_BILLBOARD = 17;
const LIBUSB_CLASS_TYPEC_BRIDGE = 18;
const LIBUSB_CLASS_MISCELLANEOUS = 239;
const LIBUSB_CLASS_APP_SPEC = 254;
const LIBUSB_CLASS_VENDOR_SPEC = 255;
const LIBUSB_ENDPOINT_IN = 0x80;
const LIBUSB_ENDPOINT_OUT = 0x00;

const USB_SS_BCD = 0x300;
const LIBUSB_DT_HUB = 0x29;
const LIBUSB_DT_SUPERSPEED_HUB = 0x2a;

/* Descriptor sizes per descriptor type */
const LIBUSB_DT_DEVICE_SIZE = 18;
const LIBUSB_DT_CONFIG_SIZE = 9;
const LIBUSB_DT_INTERFACE_SIZE = 9;
const LIBUSB_DT_ENDPOINT_SIZE = 7;
const LIBUSB_DT_ENDPOINT_AUDIO_SIZE = 9;
const LIBUSB_DT_HUB_NONVAR_SIZE = 7;

const LIBUSB_REQUEST_TYPE_STANDARD = (0x00 << 5);
const LIBUSB_REQUEST_TYPE_CLASS = (0x01 << 5);
const LIBUSB_REQUEST_TYPE_VENDOR = (0x02 << 5);
const LIBUSB_REQUEST_TYPE_RESERVED = (0x03 << 5);

const LIBUSB_RECIPIENT_DEVICE = 0x00;
const LIBUSB_RECIPIENT_INTERFACE = 0x01;
const LIBUSB_RECIPIENT_ENDPOINT = 0x02;
const LIBUSB_RECIPIENT_OTHER = 0x03;

const LIBUSB_REQUEST_GET_STATUS = 0x00;
const LIBUSB_REQUEST_CLEAR_FEATURE = 0x01;
const LIBUSB_REQUEST_SET_FEATURE = 0x03;
const LIBUSB_REQUEST_SET_ADDRESS = 0x05;
const LIBUSB_REQUEST_GET_DESCRIPTOR = 0x06;
const LIBUSB_REQUEST_SET_DESCRIPTOR = 0x07;
const LIBUSB_REQUEST_GET_CONFIGURATION = 0x08;
const LIBUSB_REQUEST_SET_CONFIGURATION = 0x09;
const LIBUSB_REQUEST_GET_INTERFACE = 0x0A;
const LIBUSB_REQUEST_SET_INTERFACE = 0x0B;
const LIBUSB_REQUEST_SYNCH_FRAME = 0x0C;
const LIBUSB_REQUEST_SET_SEL = 0x30;
const LIBUSB_SET_ISOCH_DELAY = 0x31;

const NUM_BUFS_TO_CONCAT = 4; // number of buffers to concatenate before sending data up websocket
var initComplete = false;
var templateObj;
var serviceUsb;
var usbDeviceOpen = false;
var msTimeout = 1000;
const keyPrefix = "1cbe_00ab";          // PAMB
//const keyPrefix = "1cbe_0003";        // TIVA
//const keyPrefix = "1cbe_af81";        // USB-PHI
const DFU_deviceKey = "1cbe_00ff";      // MSP432E DFU Mode

var activeKey = "";
const interfaceIndex = 0; // USB bulk interface index
var boundPktHdlr;

// TODO: Check if numBytesToCapture is always '-1'... if so, why?
function pktHdlr(numBytesToCapture, state, rxData) {
    
    if (state.discardPkts) {
        state.rxCtr += rxData.data.length;
        
        // Check if we received an incomplete packet
        if (rxData.data.length !== (512 * NUM_BUFS_TO_CONCAT)) {
            state.numBadPkts++;
        }
        
        // Benchmark every 1000th packet
        if (state.numPkts % 1000 === 0) {
            state.pktTimestamps.push(Date.now());
            if (state.pktTimestamps.length === 1) {
                state.rxCtr = 0;
            } else {
                var elapsedMs = Date.now() - state.pktTimestamps[0];
                
                if (state.pktTimestamps.length > 2) {
                    elapsedMs = state.pktTimestamps[state.pktTimestamps.length - 1] - state.pktTimestamps[state.pktTimestamps.length - 2];
                }
                
                // var kBps = state.rxCtr / elapsedMs;
                var numBytes = 1000 * 512 * NUM_BUFS_TO_CONCAT;
                var kBps = numBytes / elapsedMs;
                gc.console.log("pamb.js", "numPkts: " + state.numPkts + ", numBytes: " + state.rxCtr + ", bandwidth: " + Number(kBps).toFixed(1) + " kBytes/s, num bad length Pkts: " + state.numBadPkts);
            }
        }
    
        state.numPkts++;
        return null;
    }
    
    // Debugging: Print binary data to console...
    // NOTE: We have to copy this data to a new array, otherwise the console.log() function may
    // print out the rxData.data after the parsers has removed the parsed data from this array!!
    //const tempData = [...rxData.data];
    //console.log(tempData);
    
    // Parse RX data according to the current frame definitions
    Parser.parse(rxData.data, FrameDefinitions); 
    
    const resultObj = {
        errMsg: null,
        result: null
    };
    
    if (state.hTimeout) {
        clearTimeout(state.hTimeout);
    }
    
    // TODO: Enforce data limit (before collecting?) per browser memory limit
    // Reference: https://stackoverflow.com/questions/2936782/javascript-memory-limit
    
    let done = (numBytesToCapture === undefined);
    
    if ((!done) && (numBytesToCapture < 0) && (rxData.data.length === 4) && (getStringFromBuffer(rxData.data).indexOf("END") === 0)) {
        resultObj.result = "END. Num Bytes received = " + state.rxCtr;
        var msElapsed = +state.pktTimestamps[state.pktTimestamps.length - 1] - state.pktTimestamps[0];
        resultObj.result += ". Elapsed time for " + state.numPkts + " packets: " + msElapsed + "ms.";
        gc.console.log("pamb.js", resultObj.result);
        done = true;
    }
    
    if (!done) {
        state.pktTimestamps.push(Date.now());
        state.numPkts++;
        state.pkts.push(rxData.data);
        state.rxCtr += rxData.data.length;
        if ((numBytesToCapture > 0) && (state.rxCtr >= numBytesToCapture)) {
            gc.console.log("pamb.js", "Received " + state.rxCtr + " bytes of data - done.");
            resultObj.result = state;
        } else {
            state.hTimeout = setTimeout(() => {
                resultObj.errMsg = "Timeout waiting for data. numPkts = " + state.numPkts + ", pkt timestamps = " + state.pktTimestamps.join(",\n");
                gc.console.log("pamb.js", resultObj.errMsg);
            }, state.msTimeout);
        }
    }
    return resultObj;
}

// Error handler
function pktErrHdlr(rxError) {
    let msg = rxError;
    if (msg.message) {
        msg = rxError.message;
    }
    gc.console.error("pamb.js: pktErrHdlr error '" + msg + "'");
}

function openBulkDevice() {
    
    // Check if active device key exists
    if (!activeKey || activeKey.length === 0) {
        gc.console.warn("pamb.js: openBulkDevice() invalid key");
        return;
    }
    
    // Open and claim USB interface
    serviceUsb.openUsbDevice(activeKey).then(function(deviceInfo) {
        
        //gc.console.log("pamb.js", deviceInfo);
        if (Terminal) { Terminal.showMsg("Connecting to target device..."); }
        
        return serviceUsb.claimInterface(activeKey, interfaceIndex, true, NUM_BUFS_TO_CONCAT);
    }).then(function() {
        
        usbDeviceOpen = true;
        gc.console.log("pamb.js", "Device " + activeKey + " interface claimed. Polling started. Num bufs concatenated = " + NUM_BUFS_TO_CONCAT +'\n'); 
        
        var pktHdlrState = {
            numPkts: 0,
            numBadPkts: 0,
            rxCtr: 0,
            discardPkts: true,
            hTimeout: null,
            msTimeout: 8000,
            pktTimestamps: [],
            pkts: []
        };
        
        boundPktHdlr = pktHdlr.bind(this, -1, pktHdlrState);

        // Fire "clear to send commands" event to continue the CustomCodec.connect() process...
        //MyUtil.fireEvent('pamb_clr_cmds', "pamb.js"); //TODO: Why do we need this??
        
        // Notify CustomCodec that bulk device has connected
        CustomCodec.prototype.bulkDeviceConnected = true;
        
        return serviceUsb.addListener(activeKey, interfaceIndex, boundPktHdlr, pktErrHdlr);
        
    }).fail(function(err) {
        gc.console.error("pamb.js", "Error opening device '" + activeKey + "', error=" + err.message);
    });

}


function closeBulkDevice(isDetachEvent) {
    
    // serviceUsb.releaseInterface(activeKey, interfaceIndex).then(function() {
        
    return serviceUsb.removeListener(activeKey, interfaceIndex, boundPktHdlr, pktErrHdlr).finally(function() {
        if (!isDetachEvent) { return serviceUsb.closeUsbDevice(activeKey); }
    }).fail(function(err) {
        gc.console.error("pamb.js", "Error closing device '" + activeKey + "', error=" + err.message);
    }).finally(function() {
        usbDeviceOpen = false;
        activeKey = "";
        
        // Notify CustomCodec that bulk device has disconnected
        CustomCodec.prototype.bulkDeviceConnected = false;
        
        // TODO: Abort data collection (if in progress)
    });
}



// Flag to indicate if we are currently awaiting on a device to connect.
var deviceConnecting = false;

var deviceUpdateFunc;

// Wait for DOMContentLoaded event before trying to access the application template
var init = function() {
    
    // Save reference to template object
    templateObj = document.querySelector('#template_obj');

    // Wait for the template to fire a dom-change event to indicate that it has been 'stamped'
    // before trying to access components in the application.
    templateObj.addEventListener('dom-change', function() {
        
        if (initComplete) { return; }
        
        this.async(function() {
            
            initComplete = true;
            gc.console.debug("pamb.js", "Application template has been stamped.");
            
            // Save references to services
            serviceUsb = gc.services['ti-service-usb'];
            var serialioService = gc.services["ti-service-serialio"];
            
            // Unused references
            //var backplane = gc.services['ti-core-backplane'];
            //var connectionMgr = gc.connectionManager;
            
            // USB device connection event handler
            var deviceUpdated = function(event) {
                
                // Guard to avoid multiple calls to connect - This is not strictly necessary, but is added as a safe guard.
                // NOTE: This guard appears to fail if MULTIPLE devices (XDS110 + PAMB, for example) are connecting at the same time
                // if (!usbDeviceOpen & deviceConnecting) { return; }       // Repeated call into the connect function, so do not allow it to proceed!
                // else if (!usbDeviceOpen) { deviceConnecting = true; }    // Device is connecting, so do not allow additional calls into the connect function (if any).
                // else { deviceConnecting = false; }                       // Device is disconnecting, so allow it to connect again.
                
                // Defer the accessing of ti-service-usb until after the code that raised the event completes.
                templateObj.async(function() {
                        
                    // Find all devices with matching key prefix
                    let tiDevices = Array.from(serviceUsb.deviceInfoMap.keys()).filter((x) => (x.indexOf(keyPrefix) >= 0));
                    let dfuDevices = Array.from(serviceUsb.deviceInfoMap.keys()).filter((x) => (x.indexOf(DFU_deviceKey) >= 0));
                    
                    // Debugging...
                    gc.console.log("pamb.js", "usbDeviceListUpdated. usbDeviceOpen=" + usbDeviceOpen);
                    
                    
                    // TEMPORARY TESTING
                    const TEST_USB_MODULE = false;
                    if (TEST_USB_MODULE) {
                        
                        // DO NOT ATTEMPT TO CONNECT TO THE USB BULK INTERFACE YET...
                        // ALLOW GC TO AUTOMATICALLY CONNECT TO THE SERIAL DEVICE FIRST!
                            
                        return;
                    }
                    
                    // Check current connection state
                    // TODO: Update this logic to work with more than one EVM connected to the PC at a time.
                    if (usbDeviceOpen) { //TODO: Change this variable name to be more descriptive - WHICH USB DEVICE IS OPEN (Serial or Bulk)?
                        
                        // Device disconnected
                        if (tiDevices.length === 0) {
                            gc.console.log("pamb.js", "USB device with key " + activeKey + " removed.\n");
                            closeBulkDevice(true);
                            activeKey = "";
                        }
                        
                    } else {
                        
                        // EVM connected
                        if (tiDevices.length > 0) {
                            activeKey = tiDevices[0];
                            gc.console.log("pamb.js", "EVM USB device with key " + activeKey + " found.\n");
                            openBulkDevice();
                            
                        // DFU device connected
                        } else if (dfuDevices.length > 0) {
                            
                            alert("DFU device detected!");
                            activeKey = dfuDevices[0];
                            gc.console.log("pamb.js", "DFU USB device with key " + activeKey + " found.\n");
    
    
                            // Call BSL Scriptor tool - Make sure file names are correct!
                            MyUtil.bsl_update("bsl_app_script.txt", "INA237_238EVM_FW.txt");
                        }
                    }
                }.bind(this), 1); // Wait time for async callback
            };
            deviceUpdateFunc = deviceUpdated.bind(this);
            
            // Listen for USB device list update
            serviceUsb.addEventListener("usbDeviceListUpdated", deviceUpdateFunc);
            
            
            //
            // TODO: Determine a use for these serial port events...
            //
            
            // Serial port open event
            serialioService.addEventListener("serialPortOpen", function(event) {
                if (Terminal) { Terminal.showMsg(serialioService.selectedSerialPort.comName + ":" + serialioService.selectedBaudRate + " opened.\n"); }
                gc.console.log("pamb.js", "serialPortOpen (" + serialioService.selectedSerialPort.comName + ":" + serialioService.selectedBaudRate + ")");
            });
            
            // Serial port close event
            serialioService.addEventListener("serialPortClosed", function(event) {
                if (Terminal) { Terminal.showMsg(serialioService.selectedSerialPort.comName + ":" + serialioService.selectedBaudRate + " closed.\n"); }
                gc.console.log("pamb.js", "serialPortClosed (" + serialioService.selectedSerialPort.comName + ":" + serialioService.selectedBaudRate + ")");
            });
            
            
            // TODO: Do we need this??
            var usbHidService = gc.services['ti-service-usbhid'];
            if (usbHidService) {
                usbHidService.addEventListener('usbHidError', function(event) {
                    var detailsObj = event.detail;
                    templateObj.logMsgAndNotify("error", detailsObj.info + ": " + detailsObj.error, false, true);
                });
            }
            
            
            // "About" Pop-up dialog open event - Add firmware information to appInfoText
            let aboutBox = document.querySelector('ti-widget-aboutbox');
            if (aboutBox) {
                aboutBox.addEventListener('aboutbox_opening', function(event) {
                    aboutBox.softwareManifestLink = "app/docs/ADS1219_BoosterPack_GUI_1.0.0_manifest.html";     // TODO: Change or search for manifest file
                    aboutBox.appInfoTextHeading = 'Firmware Details';
                    var str =   'Name      : ' + EVM.id.name + '\n';
                    str = str + 'Date/Time : ' + EVM.id.date + " " + EVM.id.time + '\n';
                    str = str + 'Version   : ' + EVM.id.version;
                    aboutBox.numRowsInAppInfoTextArea = str.split(/\r\n|\r|\n/).length;
                    aboutBox.appInfoText = str;
                    
                    // TODO: Make this text area readonly and not resizable
                    // The following code works, but we need to determine when the aboutBox has loaded before we can call these functions...
                    // let tb = document.querySelector('ti-widget-aboutbox').querySelectorAll("#appInfoTextArea")[0];
                    // if (tb) {
                    //     tb.readOnly = true;
                    //     tb.style.resize = "none";
                    // }
                });
            }
            
            
            
            // EXAMPLE: How to register a button click to save data to file
            //templateObj.$.ti_widget_button.addEventListener("click", function(event) {
            //    saveText(templateObj.$.ti_widget_input.value, templateObj.$.textArea.value, 'text/plain;charset=utf-8');
            //});
            
            templateObj.showToastMsg = function(msgType, msg, durationInSeconds) {
                templateObj.$.ti_widget_toast.hideToast();
                templateObj.$.ti_widget_toast.message = msg;
                switch (msgType.toLowerCase()) {
                    case "error":
                        templateObj.$.ti_widget_toast.iconName = "error";
                        templateObj.$.ti_widget_toast.backgroundColor = "red";
                        break;
                    case "warning":
                        templateObj.$.ti_widget_toast.iconName = "warning";
                        templateObj.$.ti_widget_toast.backgroundColor = "orange";
                        break;
                    default:
                        templateObj.$.ti_widget_toast.iconName = "check";
                        templateObj.$.ti_widget_toast.backgroundColor = "teal";
                        break;
                }
                templateObj.$.ti_widget_toast.duration = +durationInSeconds;
                templateObj.$.ti_widget_toast.showToast();
                gc.console.log("regmap.js", "toast msg [" + msgType + "]: " + msg);
            };
            
            templateObj.logMsgAndNotify = function(msgType, msg, showInStatusBar, showInToast) {
                let iconName = templateObj.$.ti_widget_eventlog_view.iconForItem(msgType);
                if (showInStatusBar) {
                    let statusBar = document.querySelector("#ti_widget_statusbar");
                    if (statusBar) {
                        statusBar.statusString3 = msg;
                        //statusBar.setIcon(iconName);    // no method named setIcon
                    }
                }
                if (showInToast) { templateObj.showToastMsg(msgType, msg, 4); }
                templateObj.$.ti_widget_eventlog_view.log(msgType, msg);
            };
            
        }, 1);
        
    });
};

templateObj = document.querySelector('#template_obj');
if (templateObj) {
    init();
} else {
    document.addEventListener('DOMContentLoaded', init.bind(this));
}